#ifndef EFL_UI_SCROLLABLE_EO_HH
#define EFL_UI_SCROLLABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_scrollable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_UI_SCROLLABLE_FWD_GUARD
#define EFL_UI_SCROLLABLE_FWD_GUARD
namespace efl { namespace ui { 
struct Scrollable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Scrollable {
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_SCROLLABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Scrollable *>(this))); }
   operator ::efl::ui::Scrollable() const;
   operator ::efl::ui::Scrollable&();
   operator ::efl::ui::Scrollable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scrollable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scrollable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Scrollable : private ::efl::eo::concrete
{
   explicit Scrollable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Scrollable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Scrollable() = default;
   Scrollable(Scrollable const&) = default;
   Scrollable(Scrollable&&) = default;
   Scrollable& operator=(Scrollable const&) = default;
   Scrollable& operator=(Scrollable&&) = default;
   template <typename Derived>
   Scrollable(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Scrollable, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   static Efl_Class const* _eo_class()
   {
      return EFL_UI_SCROLLABLE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Scrollable *>(this))); }
   static struct scroll_start_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_START; }
      typedef void parameter_type;
   } const scroll_start_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_start_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_start_event, *this, std::bind(function));
   }
#endif
   static struct scroll_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL; }
      typedef void parameter_type;
   } const scroll_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_event, *this, std::bind(function));
   }
#endif
   static struct scroll_stop_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_STOP; }
      typedef void parameter_type;
   } const scroll_stop_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_stop_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_stop_event, *this, std::bind(function));
   }
#endif
   static struct scroll_up_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_UP; }
      typedef void parameter_type;
   } const scroll_up_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_up_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_up_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_up_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_up_event, *this, std::bind(function));
   }
#endif
   static struct scroll_down_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_DOWN; }
      typedef void parameter_type;
   } const scroll_down_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_down_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_down_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_down_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_down_event, *this, std::bind(function));
   }
#endif
   static struct scroll_left_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_LEFT; }
      typedef void parameter_type;
   } const scroll_left_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_left_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_left_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_left_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_left_event, *this, std::bind(function));
   }
#endif
   static struct scroll_right_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_RIGHT; }
      typedef void parameter_type;
   } const scroll_right_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_right_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_right_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_right_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_right_event, *this, std::bind(function));
   }
#endif
   static struct edge_up_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_EDGE_UP; }
      typedef void parameter_type;
   } const edge_up_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_up_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_up_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_up_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_up_event, *this, std::bind(function));
   }
#endif
   static struct edge_down_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_EDGE_DOWN; }
      typedef void parameter_type;
   } const edge_down_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_down_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_down_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_down_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_down_event, *this, std::bind(function));
   }
#endif
   static struct edge_left_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_EDGE_LEFT; }
      typedef void parameter_type;
   } const edge_left_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_left_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_left_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_left_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_left_event, *this, std::bind(function));
   }
#endif
   static struct edge_right_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_EDGE_RIGHT; }
      typedef void parameter_type;
   } const edge_right_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_right_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_right_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   edge_right_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(edge_right_event, *this, std::bind(function));
   }
#endif
   static struct scroll_anim_start_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_ANIM_START; }
      typedef void parameter_type;
   } const scroll_anim_start_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_anim_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_anim_start_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_anim_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_anim_start_event, *this, std::bind(function));
   }
#endif
   static struct scroll_anim_stop_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_ANIM_STOP; }
      typedef void parameter_type;
   } const scroll_anim_stop_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_anim_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_anim_stop_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_anim_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_anim_stop_event, *this, std::bind(function));
   }
#endif
   static struct scroll_drag_start_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_DRAG_START; }
      typedef void parameter_type;
   } const scroll_drag_start_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_drag_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_drag_start_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_drag_start_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_drag_start_event, *this, std::bind(function));
   }
#endif
   static struct scroll_drag_stop_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_EVENT_SCROLL_DRAG_STOP; }
      typedef void parameter_type;
   } const scroll_drag_stop_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_drag_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_drag_stop_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   scroll_drag_stop_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(scroll_drag_stop_event, *this, std::bind(function));
   }
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scrollable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scrollable const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Scrollable> _get_wref() const { return ::efl::eo::wref<Scrollable>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Scrollable* operator->() const { return this; }
   Scrollable* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Scrollable const& lhs, Scrollable const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Scrollable const& lhs, Scrollable const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Scrollable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Scrollable>::value, "");
} } 
#endif
